!*** Apply lowcut Laplacian filter
program Lowcut
  use sep
  use laplac2_mod
  implicit none

  integer                           :: n1, n2
  real                              :: o1, d1, o2, d2
  logical                           :: adj
  real, allocatable, dimension(:)   :: model, data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

  call from_param("adj", adj)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  allocate(model(n1*n2))
  allocate(data(n1*n2))
  model = 0.
  data = 0.

  call laplac2_init(n1, n2)

  if(adj) then
    call sep_read(data)
    call laplac2_lop2(.true., .false., model, data)
    call sep_write(model)
  else
    call sep_read(model)
    call laplac2_lop2(.false., .false., model, data)
    call sep_write(data)
  end if

  call sep_close()

end program
