/*C version of propagation kernel*/

export void gradX(uniform int adj, uniform int add,  uniform float p[], uniform float px[], uniform float r[], uniform float rx[],
                  uniform int nz, uniform int i2, uniform float dx){

uniform int n1=nz;

uniform float idx = 1.0/dx;
uniform float bx1= 160083.0/131072.0*idx;
uniform float bx2=-12705.0/131072.0*idx;
uniform float bx3= 22869.0/1310720.0*idx;
uniform float bx4=-5445.0/1835008.0*idx;
uniform float bx5= 847.0/2359296.0*idx;
uniform float bx6=-63.0/2883584.0*idx;

if(adj==1) {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      px[i1+i]=0.f;
      rx[i1+i]=0.f;
    }
  }  
  foreach(i1=0...(n1-1)){
    px[i1+i]+=
      bx1*(-p[i1+i     ]+p[i1+i-1*n1])+
      bx2*(-p[i1+i+1*n1]+p[i1+i-2*n1])+
      bx3*(-p[i1+i+2*n1]+p[i1+i-3*n1])+
      bx4*(-p[i1+i+3*n1]+p[i1+i-4*n1])+
      bx5*(-p[i1+i+4*n1]+p[i1+i-5*n1])+
      bx6*(-p[i1+i+5*n1]+p[i1+i-6*n1]);

    rx[i1+i]+=
      bx1*(-r[i1+i     ]+r[i1+i-1*n1])+
      bx2*(-r[i1+i+1*n1]+r[i1+i-2*n1])+
      bx3*(-r[i1+i+2*n1]+r[i1+i-3*n1])+
      bx4*(-r[i1+i+3*n1]+r[i1+i-4*n1])+
      bx5*(-r[i1+i+4*n1]+r[i1+i-5*n1])+
      bx6*(-r[i1+i+5*n1]+r[i1+i-6*n1]);
  }
}
else {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      px[i1+i]=0.f;
      rx[i1+i]=0.f;
    }
  }  
  foreach(i1=0...(n1-1)){
    px[i1+i]+=
      bx1*(-p[i1+i     ]+p[i1+i+1*n1])+
      bx2*(-p[i1+i-1*n1]+p[i1+i+2*n1])+
      bx3*(-p[i1+i-2*n1]+p[i1+i+3*n1])+
      bx4*(-p[i1+i-3*n1]+p[i1+i+4*n1])+
      bx5*(-p[i1+i-4*n1]+p[i1+i+5*n1])+
      bx6*(-p[i1+i-5*n1]+p[i1+i+6*n1]);

    rx[i1+i]+=
      bx1*(-r[i1+i     ]+r[i1+i+1*n1])+
      bx2*(-r[i1+i-1*n1]+r[i1+i+2*n1])+
      bx3*(-r[i1+i-2*n1]+r[i1+i+3*n1])+
      bx4*(-r[i1+i-3*n1]+r[i1+i+4*n1])+
      bx5*(-r[i1+i-4*n1]+r[i1+i+5*n1])+
      bx6*(-r[i1+i-5*n1]+r[i1+i+6*n1]);
  }
}

}
