/*C version of propagation kernel*/

export void gradZ(uniform int adj, uniform int add,  uniform float p[], uniform float pz[], uniform float r[], uniform float rz[],
                  uniform int nz, uniform int i2, uniform float dz){

uniform int n1=nz;

uniform float idz = 1.0/dz;
uniform float bz1= 160083.0/131072.0*idz;
uniform float bz2=-12705.0/131072.0*idz;
uniform float bz3= 22869.0/1310720.0*idz;
uniform float bz4=-5445.0/1835008.0*idz;
uniform float bz5= 847.0/2359296.0*idz;
uniform float bz6=-63.0/2883584.0*idz;

if(adj==1) {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      pz[i1+i]=0.f;
      rz[i1+i]=0.f;
    }
  }  
  foreach(i1=6...(n1-6)){
//    int i=i1+i2*n1;
    pz[i1+i]+=
      bz1*(-p[i1+i  ]+p[i1+i-1])+
      bz2*(-p[i1+i+1]+p[i1+i-2])+
      bz3*(-p[i1+i+2]+p[i1+i-3])+
      bz4*(-p[i1+i+3]+p[i1+i-4])+
      bz5*(-p[i1+i+4]+p[i1+i-5])+
      bz6*(-p[i1+i+5]+p[i1+i-6]);

    rz[i1+i]+=
      bz1*(-r[i1+i  ]+r[i1+i-1])+
      bz2*(-r[i1+i+1]+r[i1+i-2])+
      bz3*(-r[i1+i+2]+r[i1+i-3])+
      bz4*(-r[i1+i+3]+r[i1+i-4])+
      bz5*(-r[i1+i+4]+r[i1+i-5])+
      bz6*(-r[i1+i+5]+r[i1+i-6]);
  }
}
else {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      pz[i1+i]=0.f;
      rz[i1+i]=0.f;
    }
  }  
  foreach(i1=6...(n1-6)){
//    int i=i1+i2*n1;
    pz[i1+i]+=
      bz1*(-p[i1+i  ]+p[i1+i+1])+
      bz2*(-p[i1+i-1]+p[i1+i+2])+
      bz3*(-p[i1+i-2]+p[i1+i+3])+
      bz4*(-p[i1+i-3]+p[i1+i+4])+
      bz5*(-p[i1+i-4]+p[i1+i+5])+
      bz6*(-p[i1+i-5]+p[i1+i+6]);

    rz[i1+i]+=
      bz1*(-r[i1+i  ]+r[i1+i+1])+
      bz2*(-r[i1+i-1]+r[i1+i+2])+
      bz3*(-r[i1+i-2]+r[i1+i+3])+
      bz4*(-r[i1+i-3]+r[i1+i+4])+
      bz5*(-r[i1+i-4]+r[i1+i+5])+
      bz6*(-r[i1+i-5]+r[i1+i+6]);
  }
}

}
