/*C version of propagation kernel*/

export void gradZ2(uniform int adj, uniform int add,  uniform float p[], uniform float pzz[],
                  uniform int nz, uniform int i2, uniform float dz){

uniform int n1=nz;

uniform float idz = 1.0/(dz*dz);
uniform float a0 =-3.12513824*idz;
uniform float az1= 1.84108651*idz;
uniform float az2=-0.35706478*idz;
uniform float az3= 0.10185626*idz;
uniform float az4=-0.02924772*idz;
uniform float az5= 0.00696837*idz;
uniform float az6=-0.00102952*idz;

if(adj==1) {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      pzz[i1+i]=0.f;
    }
  }  
  foreach(i1=6...(n1-6)){
      pzz[i1+i]=
        az1*(p[i1+i-1]+   p[i1+i+1])+
        az2*(p[i1+i-2]+   p[i1+i+2])+
        az3*(p[i1+i-3]+   p[i1+i+3])+
        az4*(p[i1+i-4]+   p[i1+i+4])+
        az5*(p[i1+i-5]+   p[i1+i+5])+
        az6*(p[i1+i-6]+   p[i1+i+6])+
        a0*p[i1+i];
  }
}
else {
  uniform int i=i2*n1;
  if(add==0) {
    for(uniform int i1=0;i1<n1;i1++) {
      pzz[i1+i]=0.f;
    }
  }  
  foreach(i1=6...(n1-6)){
      pzz[i1+i]=
        az1*(p[i1+i-1]+   p[i1+i+1])+
        az2*(p[i1+i-2]+   p[i1+i+2])+
        az3*(p[i1+i-3]+   p[i1+i+3])+
        az4*(p[i1+i-4]+   p[i1+i+4])+
        az5*(p[i1+i-5]+   p[i1+i+5])+
        az6*(p[i1+i-6]+   p[i1+i+6])+
        a0*p[i1+i];
  }
}

}
