/*C version of propagation kernel*/

export void gradc(uniform float pxcur[], uniform float pxnew[], uniform float pzcur[], uniform float pznew[],
uniform int nz, uniform int nx, uniform int i2, uniform float dz, uniform float dx){

uniform int b1=nz;

uniform float idx = 1.0/dx;
uniform float idz = 1.0/dz;
uniform float bx1= 160083.0/131072.0*idx;
uniform float bx2=-12705.0/131072.0*idx;
uniform float bx3= 22869.0/1310720.0*idx;
uniform float bx4=-5445.0/1835008.0*idx;
uniform float bx5= 847.0/2359296.0*idx;
uniform float bx6=-63.0/2883584.0*idx;
uniform float bz1= 160083.0/131072.0*idz;
uniform float bz2=-12705.0/131072.0*idz;
uniform float bz3= 22869.0/1310720.0*idz;
uniform float bz4=-5445.0/1835008.0*idz;
uniform float bz5= 847.0/2359296.0*idz;
uniform float bz6=-63.0/2883584.0*idz;

foreach(i1=5...(nz-7)){
  int i=i1+i2*b1;
  pznew[i]=
    bz1*(-pzcur[i]  +pzcur[i+1])+
    bz2*(-pzcur[i-1]+pzcur[i+2])+
    bz3*(-pzcur[i-2]+pzcur[i+3])+
    bz4*(-pzcur[i-3]+pzcur[i+4])+
    bz5*(-pzcur[i-4]+pzcur[i+5])+
    bz6*(-pzcur[i-5]+pzcur[i+6]);
  pxnew[i]=
    bx1*(-pxcur[i]     +pxcur[i+1*b1])+
    bx2*(-pxcur[i-1*b1]+pxcur[i+2*b1])+
    bx3*(-pxcur[i-2*b1]+pxcur[i+3*b1])+
    bx4*(-pxcur[i-3*b1]+pxcur[i+4*b1])+
    bx5*(-pxcur[i-4*b1]+pxcur[i+5*b1])+
    bx6*(-pxcur[i-5*b1]+pxcur[i+6*b1]);
   i++;
}
}
