module lap_c_mod
use, intrinsic :: iso_c_binding
implicit none
interface

  subroutine gradX2c(adj, add, p, pxx, nz, ix, dx) &
    bind(c,name="gradX2")
    import
    real(c_float), dimension(*) :: p
    real(c_float), dimension(*) :: pxx
    integer(c_int), value :: adj
    integer(c_int), value :: add
    integer(c_int), value :: nz
    integer(c_int), value :: ix 
    real(c_float), value :: dx
  end subroutine

  subroutine gradZ2c(adj, add, p, pzz, nz, ix, dz) &
    bind(c,name="gradZ2")
    import
    real(c_float), dimension(*) :: p
    real(c_float), dimension(*) :: pzz
    integer(c_int), value :: adj
    integer(c_int), value :: add
    integer(c_int), value :: nz
    integer(c_int), value :: ix 
    real(c_float), value :: dz
  end subroutine

  subroutine gradXc(adj, add, p, px, r, rx, nz, ix, dx) &
    bind(c,name="gradX")
    import
    real(c_float), dimension(*) :: p
    real(c_float), dimension(*) :: px
    real(c_float), dimension(*) :: r
    real(c_float), dimension(*) :: rx
    integer(c_int), value :: adj
    integer(c_int), value :: add
    integer(c_int), value :: nz
    integer(c_int), value :: ix 
    real(c_float), value :: dx
  end subroutine

  subroutine gradZc(adj, add, p, pz, r, rz, nz, ix, dz) &
    bind(c,name="gradZ")
    import
    real(c_float), dimension(*) :: p
    real(c_float), dimension(*) :: pz
    real(c_float), dimension(*) :: r
    real(c_float), dimension(*) :: rz
    integer(c_int), value :: adj
    integer(c_int), value :: add
    integer(c_int), value :: nz
    integer(c_int), value :: ix 
    real(c_float), value :: dz
  end subroutine

  subroutine gradXceic(adj, add, p, px, nz, ix, dx) &
    bind(c,name="gradXeic")
    import
    real(c_float), dimension(*) :: p
    real(c_float), dimension(*) :: px
    integer(c_int), value :: adj
    integer(c_int), value :: add
    integer(c_int), value :: nz
    integer(c_int), value :: ix 
    real(c_float), value :: dx
  end subroutine

  subroutine gradZceic(adj, add, r, rz, nz, ix, dz) &
    bind(c,name="gradZeic")
    import
    real(c_float), dimension(*) :: r
    real(c_float), dimension(*) :: rz
    integer(c_int), value :: adj
    integer(c_int), value :: add
    integer(c_int), value :: nz
    integer(c_int), value :: ix 
    real(c_float), value :: dz
  end subroutine
end interface
end module
