/*C version of propagation kernel*/

export void props_tti(uniform float pxxcur[], uniform float pxxnew[],
                      uniform float pzzcur[], uniform float pzznew[],
                      uniform float rxxcur[], uniform float rxxnew[],
                      uniform float rzzcur[], uniform float rzznew[],
                      uniform int nz, uniform int nx,
                      uniform int i2, uniform float dz, uniform float dx){

uniform int b1=nz;

uniform float idx = 1.0/(dx*dx);
uniform float idz = 1.0/(dz*dz);
uniform float a0=-3.12513824*(idx+idz);
uniform float ax1= 1.84108651*idx;
uniform float ax2=-0.35706478*idx;
uniform float ax3= 0.10185626*idx;
uniform float ax4=-0.02924772*idx;
uniform float ax5= 0.00696837*idx;
uniform float ax6=-0.00102952*idx;
uniform float az1= 1.84108651*idz;
uniform float az2=-0.35706478*idz;
uniform float az3= 0.10185626*idz;
uniform float az4=-0.02924772*idz;
uniform float az5= 0.00696837*idz;
uniform float az6=-0.00102952*idz;

foreach(i1=6...(nz-7)){
  int i=i1+i2*b1;
  pxxnew[i]=
    ax1*(pxxcur[i-1*b1]+pxxcur[i+1*b1])+
    ax2*(pxxcur[i-2*b1]+pxxcur[i+2*b1])+
    ax3*(pxxcur[i-3*b1]+pxxcur[i+3*b1])+
    ax4*(pxxcur[i-4*b1]+pxxcur[i+4*b1])+
    ax5*(pxxcur[i-5*b1]+pxxcur[i+5*b1])+
    ax6*(pxxcur[i-6*b1]+pxxcur[i+6*b1])+
    a0 * pxxcur[i]*0.5;
  pzznew[i]=
    az1*(pzzcur[i-1]+pzzcur[i+1])+
    az2*(pzzcur[i-2]+pzzcur[i+2])+
    az3*(pzzcur[i-3]+pzzcur[i+3])+
    az4*(pzzcur[i-4]+pzzcur[i+4])+
    az5*(pzzcur[i-5]+pzzcur[i+5])+
    az6*(pzzcur[i-6]+pzzcur[i+6])+
    a0 * pzzcur[i]*0.5;
  rxxnew[i]=
    ax1*(rxxcur[i-1*b1]+rxxcur[i+1*b1])+
    ax2*(rxxcur[i-2*b1]+rxxcur[i+2*b1])+
    ax3*(rxxcur[i-3*b1]+rxxcur[i+3*b1])+
    ax4*(rxxcur[i-4*b1]+rxxcur[i+4*b1])+
    ax5*(rxxcur[i-5*b1]+rxxcur[i+5*b1])+
    ax6*(rxxcur[i-6*b1]+rxxcur[i+6*b1])+
    a0 * rxxcur[i]*0.5;
  rzznew[i]=
    az1*(rzzcur[i-1]+rzzcur[i+1])+
    az2*(rzzcur[i-2]+rzzcur[i+2])+
    az3*(rzzcur[i-3]+rzzcur[i+3])+
    az4*(rzzcur[i-4]+rzzcur[i+4])+
    az5*(rzzcur[i-5]+rzzcur[i+5])+
    az6*(rzzcur[i-6]+rzzcur[i+6])+
    a0 * rzzcur[i]*0.5;
   i++;
}

}
