/*C version of propagation kernel*/

export void props_vti(uniform float pcur[], uniform float pnew[], uniform float rcur[],
                      uniform float rnew[], uniform int nz, uniform int nx,
                      uniform int i2, uniform float dz, uniform float dx){

uniform int b1=nz;

uniform float idx = 1.0/(dx*dx);
uniform float idz = 1.0/(dz*dz);
uniform float a0=-3.12513824*(idx+idz);
uniform float ax1= 1.84108651*idx;
uniform float ax2=-0.35706478*idx;
uniform float ax3= 0.10185626*idx;
uniform float ax4=-0.02924772*idx;
uniform float ax5= 0.00696837*idx;
uniform float ax6=-0.00102952*idx;
uniform float az1= 1.84108651*idz;
uniform float az2=-0.35706478*idz;
uniform float az3= 0.10185626*idz;
uniform float az4=-0.02924772*idz;
uniform float az5= 0.00696837*idz;
uniform float az6=-0.00102952*idz;

foreach(i1=6...(nz-7)){
  int i=i1+i2*b1;
  rnew[i]=
    az1*(rcur[i-1]+rcur[i+1])+
    az2*(rcur[i-2]+rcur[i+2])+
    az3*(rcur[i-3]+rcur[i+3])+
    az4*(rcur[i-4]+rcur[i+4])+
    az5*(rcur[i-5]+rcur[i+5])+
    az6*(rcur[i-6]+rcur[i+6])+
    a0 * rcur[i]*0.5;
  pnew[i]=
    ax1*(pcur[i-1*b1]+pcur[i+1*b1])+
    ax2*(pcur[i-2*b1]+pcur[i+2*b1])+
    ax3*(pcur[i-3*b1]+pcur[i+3*b1])+
    ax4*(pcur[i-4*b1]+pcur[i+4*b1])+
    ax5*(pcur[i-5*b1]+pcur[i+5*b1])+
    ax6*(pcur[i-6*b1]+pcur[i+6*b1])+
    a0 * pcur[i]*0.5;
   i++;
}

}
